## rt-tests 1.0

=== Makefile ===
VERSION = 1.0
CC?=$(CROSS_COMPILE)gcc
AR?=$(CROSS_COMPILE)ar

OBJDIR = bld

sources = cyclictest.c \
	  hackbench.c \
	  pip_stress.c \
	  pi_stress.c \
	  pmqtest.c \
	  ptsematest.c \
	  rt-migrate-test.c \
	  sendme.c \
	  signaltest.c \
	  sigwaittest.c \
	  svsematest.c

TARGETS = $(sources:.c=)
LIBS	= -lrt -lpthread
RTTESTLIB = -lrttest -L$(OBJDIR)
EXTRA_LIBS ?= -ldl	# for get_cpu
DESTDIR	?=
prefix  ?= /usr/local
bindir  ?= $(prefix)/bin
mandir	?= $(prefix)/share/man
srcdir	?= $(prefix)/src

CFLAGS ?= -Wall -Wno-nonnull
CPPFLAGS += -D_GNU_SOURCE -Isrc/include
LDFLAGS ?=

PYLIB  ?= $(shell python -c 'import distutils.sysconfig;  print distutils.sysconfig.get_python_lib()')

ifndef DEBUG
	CFLAGS	+= -O2
else
	CFLAGS	+= -O0 -g
endif

# We make some gueses on how to compile rt-tests based on the machine type
# and the ostype. These can often be overridden.
dumpmachine := $(shell $(CC) -dumpmachine)

# The ostype is typically something like linux or android
ostype := $(lastword $(subst -, ,$(dumpmachine)))

machinetype := $(shell echo $(dumpmachine)| \
    sed -e 's/-.*//' -e 's/i.86/i386/' -e 's/mips.*/mips/' -e 's/ppc.*/powerpc/')

# The default is to assume you have libnuma installed, which is fine to do
# even on non-numa machines. If you don't want to install the numa libs, for
# example, they might not be available in an embedded environment, then
# compile with
# make NUMA=0
ifneq ($(filter x86_64 i386 ia64 mips powerpc,$(machinetype)),)
NUMA 	:= 1
endif

# The default is to assume that you have numa_parse_cpustring_all
# If you have an older version of libnuma that only has numa_parse_cpustring
# then compile with
# make HAVE_PARSE_CPUSTRING_ALL=0
HAVE_PARSE_CPUSTRING_ALL?=1
ifeq ($(NUMA),1)
	CFLAGS += -DNUMA
	NUMA_LIBS = -lnuma
	ifeq ($(HAVE_PARSE_CPUSTRING_ALL),1)
		CFLAGS += -DHAVE_PARSE_CPUSTRING_ALL
	endif
endif

include src/arch/android/Makefile

VPATH	= src/cyclictest:
VPATH	+= src/signaltest:
VPATH	+= src/pi_tests:
VPATH	+= src/rt-migrate-test:
VPATH	+= src/ptsematest:
VPATH	+= src/sigwaittest:
VPATH	+= src/svsematest:
VPATH	+= src/pmqtest:
VPATH	+= src/backfire:
VPATH	+= src/lib:
VPATH	+= src/hackbench:

$(OBJDIR)/%.o: %.c | $(OBJDIR)
	$(CC) -D VERSION=$(VERSION) -c $< $(CFLAGS) $(CPPFLAGS) -o $@

# Pattern rule to generate dependency files from .c files
$(OBJDIR)/%.d: %.c | $(OBJDIR)
	@$(CC) -MM $(CFLAGS) $(CPPFLAGS) $< | sed 's,\($*\)\.o[ :]*,\1.o $@ : ,g' > $@ || rm -f $@

.PHONY: all
all: $(TARGETS) hwlatdetect | $(OBJDIR)

$(OBJDIR):
	mkdir $(OBJDIR)

# Include dependency files, automatically generate them if needed.
-include $(addprefix $(OBJDIR)/,$(sources:.c=.d))

cyclictest: $(OBJDIR)/cyclictest.o $(OBJDIR)/librttest.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB) $(NUMA_LIBS)

signaltest: $(OBJDIR)/signaltest.o $(OBJDIR)/librttest.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB)

pi_stress: $(OBJDIR)/pi_stress.o $(OBJDIR)/librttest.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB)

hwlatdetect:  src/hwlatdetect/hwlatdetect.py
	chmod +x src/hwlatdetect/hwlatdetect.py
	ln -s src/hwlatdetect/hwlatdetect.py hwlatdetect

rt-migrate-test: $(OBJDIR)/rt-migrate-test.o $(OBJDIR)/librttest.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB)

ptsematest: $(OBJDIR)/ptsematest.o $(OBJDIR)/librttest.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB) $(EXTRA_LIBS)

sigwaittest: $(OBJDIR)/sigwaittest.o $(OBJDIR)/librttest.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB) $(EXTRA_LIBS)

svsematest: $(OBJDIR)/svsematest.o $(OBJDIR)/librttest.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB) $(EXTRA_LIBS)

pmqtest: $(OBJDIR)/pmqtest.o $(OBJDIR)/librttest.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB) $(EXTRA_LIBS)

sendme: $(OBJDIR)/sendme.o $(OBJDIR)/librttest.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB) $(EXTRA_LIBS)

pip_stress: $(OBJDIR)/pip_stress.o $(OBJDIR)/librttest.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB)

hackbench: $(OBJDIR)/hackbench.o
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS)

LIBOBJS =$(addprefix $(OBJDIR)/,error.o rt-get_cpu.o rt-sched.o rt-utils.o)
$(OBJDIR)/librttest.a: $(LIBOBJS)
	$(AR) rcs $@ $^

CLEANUP  = $(TARGETS) *.o .depend *.*~ *.orig *.rej *.d *.a
CLEANUP += $(if $(wildcard .git), ChangeLog)

.PHONY: clean
clean:
	for F in $(CLEANUP); do find -type f -name $$F | xargs rm -f; done
	rm -f rt-tests-*.tar
	rm -f hwlatdetect
	rm -f tags

RPMDIRS = BUILD BUILDROOT RPMS SRPMS SPECS
.PHONY: distclean
distclean: clean
	rm -rf $(RPMDIRS) releases *.tar.gz *.tar.asc tmp

.PHONY: rebuild
rebuild:
	$(MAKE) clean
	$(MAKE) all

.PHONY: install
install: all install_hwlatdetect
	mkdir -p "$(DESTDIR)$(bindir)" "$(DESTDIR)$(mandir)/man4"
	mkdir -p "$(DESTDIR)$(srcdir)" "$(DESTDIR)$(mandir)/man8"
	cp $(TARGETS) "$(DESTDIR)$(bindir)"
	install -D -m 644 src/backfire/backfire.c "$(DESTDIR)$(srcdir)/backfire/backfire.c"
	install -m 644 src/backfire/Makefile "$(DESTDIR)$(srcdir)/backfire/Makefile"
	gzip -c src/backfire/backfire.4 >"$(DESTDIR)$(mandir)/man4/backfire.4.gz"
	gzip -c src/cyclictest/cyclictest.8 >"$(DESTDIR)$(mandir)/man8/cyclictest.8.gz"
	gzip -c src/pi_tests/pi_stress.8 >"$(DESTDIR)$(mandir)/man8/pi_stress.8.gz"
	gzip -c src/ptsematest/ptsematest.8 >"$(DESTDIR)$(mandir)/man8/ptsematest.8.gz"
	gzip -c src/sigwaittest/sigwaittest.8 >"$(DESTDIR)$(mandir)/man8/sigwaittest.8.gz"
	gzip -c src/svsematest/svsematest.8 >"$(DESTDIR)$(mandir)/man8/svsematest.8.gz"
	gzip -c src/pmqtest/pmqtest.8 >"$(DESTDIR)$(mandir)/man8/pmqtest.8.gz"
	gzip -c src/backfire/sendme.8 >"$(DESTDIR)$(mandir)/man8/sendme.8.gz"
	gzip -c src/hackbench/hackbench.8 >"$(DESTDIR)$(mandir)/man8/hackbench.8.gz"
	gzip -c src/signaltest/signaltest.8 >"$(DESTDIR)$(mandir)/man8/signaltest.8.gz"

.PHONY: install_hwlatdetect
install_hwlatdetect: hwlatdetect
	if test -n "$(PYLIB)" ; then \
		mkdir -p "$(DESTDIR)$(bindir)" "$(DESTDIR)$(mandir)/man8" ; \
		install -D -m 755 src/hwlatdetect/hwlatdetect.py $(DESTDIR)$(PYLIB)/hwlatdetect.py ; \
		rm -f "$(DESTDIR)$(bindir)/hwlatdetect" ; \
		ln -s $(PYLIB)/hwlatdetect.py "$(DESTDIR)$(bindir)/hwlatdetect" ; \
		gzip -c src/hwlatdetect/hwlatdetect.8 >"$(DESTDIR)$(mandir)/man8/hwlatdetect.8.gz" ; \
	fi

.PHONY: tarball
tarball:
	git archive --worktree-attributes --prefix=rt-tests-${VERSION}/ -o rt-tests-${VERSION}.tar v${VERSION}

.PHONY: help
help:
	@echo ""
	@echo " rt-tests useful Makefile targets:"
	@echo ""
	@echo "    all       :  build all tests (default"
	@echo "    install   :  install tests to local filesystem"
	@echo "    clean     :  remove object files"
	@echo "    distclean :  remove all generated files"
	@echo "    tarball   :  make a rt-tests tarball suitable for release"
	@echo "    help      :  print this message"

.PHONY: tags
tags:
	ctags -R --extra=+f --c-kinds=+p --exclude=tmp --exclude=BUILD *

=== debian/changelog ===
rt-tests (1.0-3) unstable; urgency=medium

  * drop Recommends to dropped package backfire-dkms (Closes: #869960).

 -- Uwe Kleine-König <ukleinek@debian.org>  Fri, 28 Jul 2017 08:10:02 +0200

rt-tests (1.0-2) unstable; urgency=medium

  * drop backfire kernel module package (Closes: #867706)

 -- Uwe Kleine-König <ukleinek@debian.org>  Sun, 16 Jul 2017 22:11:31 +0200

rt-tests (1.0-1) unstable; urgency=medium

  * new upstream stable release
  * new patch cherry picked from upstream/master to install rt-migrate-test's
    manpage
  * Standards-Version: 3.9.8 (no changes needed)

 -- Uwe Kleine-König <ukleinek@debian.org>  Sun, 19 Jun 2016 23:46:40 +0200

rt-tests (0.97-1) unstable; urgency=medium

  * debian/watch: check upstream's signature
  * new upstream release 

 -- Uwe Kleine-König <ukleinek@debian.org>  Thu, 14 Apr 2016 09:21:14 +0200

rt-tests (0.96-1) unstable; urgency=medium

  * new upstream release 
    - drop Fix-VERSION-in-rt-migrate-test.patch which was applied for 0.94
  * switch maintainer entry to debian.org address

 -- Uwe Kleine-König <ukleinek@debian.org>  Fri, 22 Jan 2016 22:20:51 +0100

=== debian/control ===
Source: rt-tests
Section: misc
Priority: extra
Maintainer: Uwe Kleine-König <ukleinek@debian.org>
Standards-Version: 3.9.8
Build-Depends: debhelper (>= 9), libnuma-dev (>= 2.0.3) [amd64 i386 ia64 mips mipsel mipsn32 mipsn32el mips64 mips64el powerpc powerpcspe ppc64 x32]
Vcs-Browser: http://git.pengutronix.de/?p=ukl/rt-tests.git;
Vcs-Git: git://git.pengutronix.de/git/ukl/rt-tests.git

Package: rt-tests
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, python,
 libnuma1 (>= 2.0.3) [amd64 i386 ia64 mips mipsel powerpc]
Conflicts: xenomai-runtime
Description: Test programs for rt kernels
 rt-tests contains a set of programs that test and measure various components
 of real-time kernel behavior, such as timer latency, signal latency and the
 functioning of priority-inheritance mutexes.
 Additionally it contains hackbench, a program to generate work for the
 scheduler.

=== debian/rules ===
#!/usr/bin/make -f

export prefix=/usr

ifneq (,$(findstring $(DEB_BUILD_ARCH), amd64 i386 ia64 mips mipsel mipsn32 mipsn32el mips64 mips64el powerpc))
export NUMA=1
endif

DH_SEQUENCE = $@
DH = dh $(DH_SEQUENCE)

build-arch: build-arch-stamp
build-indep:
build: build-arch build-indep

install: build install-stamp

build-arch-stamp install-stamp: DH_SEQUENCE = ${@:-stamp=}
build-arch-stamp install-stamp:
	$(DH)
	touch $@

binary-arch binary-indep: install
	$(DH)

binary: binary-arch binary-indep

clean:
	$(DH)

.PHONY: build-arch build-indep build clean install binary-indep binary-arch binary

=== debian/watch ===
version=4

opts="pgpsigurlmangle=s%.xz$%.sign%, decompress" \
http://www.kernel.org/pub/linux/utils/rt-tests/rt-tests-(.*)\.tar\.xz

## rt-tests 1.5

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION = 1.0
+VERSION = 1.5
 CC?=$(CROSS_COMPILE)gcc
 AR?=$(CROSS_COMPILE)ar
 
@@ -11,10 +11,13 @@
 	  pmqtest.c \
 	  ptsematest.c \
 	  rt-migrate-test.c \
-	  sendme.c \
 	  signaltest.c \
 	  sigwaittest.c \
-	  svsematest.c
+	  svsematest.c  \
+	  cyclicdeadline.c \
+	  deadline_test.c \
+	  queuelat.c \
+	  ssdd.c
 
 TARGETS = $(sources:.c=)
 LIBS	= -lrt -lpthread
@@ -30,10 +33,10 @@
 CPPFLAGS += -D_GNU_SOURCE -Isrc/include
 LDFLAGS ?=
 
-PYLIB  ?= $(shell python -c 'import distutils.sysconfig;  print distutils.sysconfig.get_python_lib()')
+PYLIB  ?= $(shell python3 -c 'import distutils.sysconfig;  print (distutils.sysconfig.get_python_lib())')
 
 ifndef DEBUG
-	CFLAGS	+= -O2
+	CFLAGS	+= -O2 -g
 else
 	CFLAGS	+= -O0 -g
 endif
@@ -80,9 +83,11 @@
 VPATH	+= src/sigwaittest:
 VPATH	+= src/svsematest:
 VPATH	+= src/pmqtest:
-VPATH	+= src/backfire:
 VPATH	+= src/lib:
 VPATH	+= src/hackbench:
+VPATH	+= src/sched_deadline:
+VPATH	+= src/queuelat:	
+VPATH	+= src/ssdd:
 
 $(OBJDIR)/%.o: %.c | $(OBJDIR)
 	$(CC) -D VERSION=$(VERSION) -c $< $(CFLAGS) $(CPPFLAGS) -o $@
@@ -103,6 +108,12 @@
 cyclictest: $(OBJDIR)/cyclictest.o $(OBJDIR)/librttest.a
 	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB) $(NUMA_LIBS)
 
+cyclicdeadline: $(OBJDIR)/cyclicdeadline.o $(OBJDIR)/librttest.a
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB)
+
+deadline_test: $(OBJDIR)/deadline_test.o $(OBJDIR)/librttest.a
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB)
+
 signaltest: $(OBJDIR)/signaltest.o $(OBJDIR)/librttest.a
 	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB)
 
@@ -128,14 +139,17 @@
 pmqtest: $(OBJDIR)/pmqtest.o $(OBJDIR)/librttest.a
 	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB) $(EXTRA_LIBS)
 
-sendme: $(OBJDIR)/sendme.o $(OBJDIR)/librttest.a
-	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB) $(EXTRA_LIBS)
-
 pip_stress: $(OBJDIR)/pip_stress.o $(OBJDIR)/librttest.a
 	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB)
 
 hackbench: $(OBJDIR)/hackbench.o
 	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS)
+
+queuelat: $(OBJDIR)/queuelat.o $(OBJDIR)/librttest.a
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB)
+
+ssdd: $(OBJDIR)/ssdd.o $(OBJDIR)/librttest.a
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB)
 
 LIBOBJS =$(addprefix $(OBJDIR)/,error.o rt-get_cpu.o rt-sched.o rt-utils.o)
 $(OBJDIR)/librttest.a: $(LIBOBJS)
@@ -166,18 +180,21 @@
 	mkdir -p "$(DESTDIR)$(bindir)" "$(DESTDIR)$(mandir)/man4"
 	mkdir -p "$(DESTDIR)$(srcdir)" "$(DESTDIR)$(mandir)/man8"
 	cp $(TARGETS) "$(DESTDIR)$(bindir)"
-	install -D -m 644 src/backfire/backfire.c "$(DESTDIR)$(srcdir)/backfire/backfire.c"
-	install -m 644 src/backfire/Makefile "$(DESTDIR)$(srcdir)/backfire/Makefile"
-	gzip -c src/backfire/backfire.4 >"$(DESTDIR)$(mandir)/man4/backfire.4.gz"
+	install src/queuelat/get_cpuinfo_mhz.sh "$(DESTDIR)$(bindir)"
+	install src/queuelat/determine_maximum_mpps.sh "${DESTDIR}${bindir}"
 	gzip -c src/cyclictest/cyclictest.8 >"$(DESTDIR)$(mandir)/man8/cyclictest.8.gz"
 	gzip -c src/pi_tests/pi_stress.8 >"$(DESTDIR)$(mandir)/man8/pi_stress.8.gz"
 	gzip -c src/ptsematest/ptsematest.8 >"$(DESTDIR)$(mandir)/man8/ptsematest.8.gz"
+	gzip -c src/rt-migrate-test/rt-migrate-test.8 >"$(DESTDIR)$(mandir)/man8/rt-migrate-test.8.gz"
 	gzip -c src/sigwaittest/sigwaittest.8 >"$(DESTDIR)$(mandir)/man8/sigwaittest.8.gz"
 	gzip -c src/svsematest/svsematest.8 >"$(DESTDIR)$(mandir)/man8/svsematest.8.gz"
 	gzip -c src/pmqtest/pmqtest.8 >"$(DESTDIR)$(mandir)/man8/pmqtest.8.gz"
-	gzip -c src/backfire/sendme.8 >"$(DESTDIR)$(mandir)/man8/sendme.8.gz"
 	gzip -c src/hackbench/hackbench.8 >"$(DESTDIR)$(mandir)/man8/hackbench.8.gz"
 	gzip -c src/signaltest/signaltest.8 >"$(DESTDIR)$(mandir)/man8/signaltest.8.gz"
+	gzip -c src/pi_tests/pip_stress.8 >"$(DESTDIR)$(mandir)/man8/pip_stress.8.gz"
+	gzip -c src/queuelat/queuelat.8 >"$(DESTDIR)$(mandir)/man8/queuelat.8.gz"
+	gzip -c src/sched_deadline/deadline_test.8 >"$(DESTDIR)$(mandir)/man8/deadline_test.8.gz"
+	gzip -c src/ssdd/ssdd.8 >"$(DESTDIR)$(mandir)/man8/ssdd.8.gz"
 
 .PHONY: install_hwlatdetect
 install_hwlatdetect: hwlatdetect

=== src/queuelat/Makefile ===
queuelat: queuelat.o
	cc -o queuelat queuelat.o

queuelat.o: queuelat.c
	cc -c -Wall queuelat.c

clean:
	rm queuelat queuelat.o

=== debian/changelog ===
rt-tests (1.5-2) unstable; urgency=medium

  * drop Conflicts to xenomai-runtime which only exists in Jessie.
  * Fix FTBFS on all platforms but arm{el,hf} and x86.

 -- Uwe Kleine-König <ukleinek@debian.org>  Sun, 08 Dec 2019 22:15:22 +0100

rt-tests (1.5-1) unstable; urgency=medium

  * Fix selection for building with or without NUMA (Closes: #930836)
  * New upstream release making several patches unnecessary:
    - dont-build-backfile: done independently in commit 2829763fdd79
      ("rt-tests: Remove install and build of backfire and sendme")
    - install_manpage_rt-migrate-test: Corresponds to upstream commit
      dff174f994f5 ("rt-tests: Makefile: Add missing install of
      rt-migrate-test.8 man page")
    - manpage_pip_stress: Upstream provides a manpage since commit
      c2cf910af821 ("rt-tests: pip_stress: Add an initial man page for
      pip_stress")
    Refresh remaining patches and d/copyright.
    Also upstream switched to python3 (Closes: #945734).
  * Adapt VCS-Browser and VCS-Git to reality.
  * Move to Priority: optional (as per Policy section 2.5)
  * Bump Standards-Version to 4.4.1.
  * Depend on python3 instead of python as all scripts use the new interpreter
    version now.
  * Update d/watch to use https.
  * Enable hardening
  * bump debhelper compat level to 12

 -- Uwe Kleine-König <ukleinek@debian.org>  Thu, 05 Dec 2019 17:08:10 +0100

=== debian/control ===
Source: rt-tests
Section: misc
Priority: optional
Maintainer: Uwe Kleine-König <ukleinek@debian.org>
Standards-Version: 4.4.1
Build-Depends: debhelper-compat (= 12), libnuma-dev (>= 2.0.3) [amd64 i386 ia64 mips mipsel mipsn32 mipsn32el mips64 mips64el powerpc powerpcspe ppc64 x32]
Vcs-Browser: https://git.pengutronix.de/cgit/ukl/rt-tests
Vcs-Git: https://git.pengutronix.de/git/ukl/rt-tests

Package: rt-tests
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3,
 libnuma1 (>= 2.0.3) [amd64 i386 ia64 mips mipsel powerpc]
Description: Test programs for rt kernels
 rt-tests contains a set of programs that test and measure various components
 of real-time kernel behavior, such as timer latency, signal latency and the
 functioning of priority-inheritance mutexes.
 Additionally it contains hackbench, a program to generate work for the
 scheduler.

=== debian/rules ===
--- 
+++ 
@@ -1,8 +1,9 @@
 #!/usr/bin/make -f
 
 export prefix=/usr
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
-ifneq (,$(findstring $(DEB_BUILD_ARCH), amd64 i386 ia64 mips mipsel mipsn32 mipsn32el mips64 mips64el powerpc))
+ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 i386 ia64 mips mipsel mipsn32 mipsn32el mips64 mips64el powerpc powerpcspe ppc64 x32))
 export NUMA=1
 endif

## rt-tests 2.2

=== Makefile ===
VERSION = 2.2
CC = $(CROSS_COMPILE)gcc
AR = $(CROSS_COMPILE)ar

OBJDIR = bld

sources = cyclictest.c \
	  hackbench.c \
	  pip_stress.c \
	  pi_stress.c \
	  pmqtest.c \
	  ptsematest.c \
	  rt-migrate-test.c \
	  signaltest.c \
	  sigwaittest.c \
	  svsematest.c  \
	  cyclicdeadline.c \
	  deadline_test.c \
	  queuelat.c \
	  ssdd.c \
	  oslat.c

TARGETS = $(sources:.c=)
LIBS	= -lrt -lpthread
RTTESTLIB = -lrttest -L$(OBJDIR)
EXTRA_LIBS ?= -ldl	# for get_cpu
RTTESTNUMA = -lrttestnuma -lnuma
DESTDIR	?=
prefix  ?= /usr/local
bindir  ?= $(prefix)/bin
mandir	?= $(prefix)/share/man

CFLAGS ?= -Wall -Wno-nonnull
CPPFLAGS += -D_GNU_SOURCE -Isrc/include
LDFLAGS ?=

PYLIB  ?= $(shell python3 -c 'import distutils.sysconfig;  print (distutils.sysconfig.get_python_lib())')

# Check for errors, such as python3 not available
ifeq (${PYLIB},)
	undefine PYLIB
endif

MANPAGES = src/cyclictest/cyclictest.8 \
	   src/pi_tests/pi_stress.8 \
	   src/ptsematest/ptsematest.8 \
	   src/rt-migrate-test/rt-migrate-test.8 \
	   src/sigwaittest/sigwaittest.8 \
	   src/svsematest/svsematest.8 \
	   src/pmqtest/pmqtest.8 \
	   src/hackbench/hackbench.8 \
	   src/signaltest/signaltest.8 \
	   src/pi_tests/pip_stress.8 \
	   src/queuelat/queuelat.8 \
	   src/queuelat/determine_maximum_mpps.8 \
	   src/sched_deadline/deadline_test.8 \
	   src/ssdd/ssdd.8 \
	   src/sched_deadline/cyclicdeadline.8 \
	   src/oslat/oslat.8

ifdef PYLIB
	MANPAGES += src/cyclictest/get_cyclictest_snapshot.8 \
	src/hwlatdetect/hwlatdetect.8
endif

ifeq ($(MAN_COMPRESSION),gzip)
	MANPAGES := $(MANPAGES:.8=.8.gz)
else ifeq ($(MAN_COMPRESSION),bzip2)
	MANPAGES := $(MANPAGES:.8=.8.bz2)
endif

ifndef DEBUG
	CFLAGS	+= -O2 -g
else
	CFLAGS	+= -O0 -g
endif

# We make some gueses on how to compile rt-tests based on the machine type
# and the ostype. These can often be overridden.
dumpmachine := $(shell $(CC) -dumpmachine)

# The ostype is typically something like linux or android
ostype := $(lastword $(subst -, ,$(dumpmachine)))

machinetype := $(shell echo $(dumpmachine)| \
    sed -e 's/-.*//' -e 's/i.86/i386/' -e 's/mips.*/mips/' -e 's/ppc.*/powerpc/')

include src/arch/android/Makefile

VPATH	= src/cyclictest:
VPATH	+= src/signaltest:
VPATH	+= src/pi_tests:
VPATH	+= src/rt-migrate-test:
VPATH	+= src/ptsematest:
VPATH	+= src/sigwaittest:
VPATH	+= src/svsematest:
VPATH	+= src/pmqtest:
VPATH	+= src/lib:
VPATH	+= src/hackbench:
VPATH	+= src/sched_deadline:
VPATH	+= src/queuelat:	
VPATH	+= src/ssdd:
VPATH	+= src/oslat:

$(OBJDIR)/%.o: %.c | $(OBJDIR)
	$(CC) -D VERSION=$(VERSION) -c $< $(CFLAGS) $(CPPFLAGS) -o $@

# Pattern rule to generate dependency files from .c files
$(OBJDIR)/%.d: %.c | $(OBJDIR)
	@$(CC) -MM $(CFLAGS) $(CPPFLAGS) $< | sed 's,\($*\)\.o[ :]*,\1.o $@ : ,g' > $@ || rm -f $@

.PHONY: all
all: $(TARGETS) hwlatdetect get_cyclictest_snapshot | $(OBJDIR)

$(OBJDIR):
	mkdir $(OBJDIR)

# Include dependency files, automatically generate them if needed.
-include $(addprefix $(OBJDIR)/,$(sources:.c=.d))

cyclictest: $(OBJDIR)/cyclictest.o $(OBJDIR)/librttest.a $(OBJDIR)/librttestnuma.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB) $(RTTESTNUMA)

cyclicdeadline: $(OBJDIR)/cyclicdeadline.o $(OBJDIR)/librttest.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB)

deadline_test: $(OBJDIR)/deadline_test.o $(OBJDIR)/librttest.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB)

signaltest: $(OBJDIR)/signaltest.o $(OBJDIR)/librttest.a $(OBJDIR)/librttestnuma.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB) $(RTTESTNUMA)

pi_stress: $(OBJDIR)/pi_stress.o $(OBJDIR)/librttest.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB)

hwlatdetect:  src/hwlatdetect/hwlatdetect.py
	chmod +x src/hwlatdetect/hwlatdetect.py
	ln -s src/hwlatdetect/hwlatdetect.py hwlatdetect

get_cyclictest_snapshot: src/cyclictest/get_cyclictest_snapshot.py
	chmod +x src/cyclictest/get_cyclictest_snapshot.py
	ln -s src/cyclictest/get_cyclictest_snapshot.py get_cyclictest_snapshot

rt-migrate-test: $(OBJDIR)/rt-migrate-test.o $(OBJDIR)/librttest.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB)

ptsematest: $(OBJDIR)/ptsematest.o $(OBJDIR)/librttest.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB) $(EXTRA_LIBS)

sigwaittest: $(OBJDIR)/sigwaittest.o $(OBJDIR)/librttest.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB) $(EXTRA_LIBS)

svsematest: $(OBJDIR)/svsematest.o $(OBJDIR)/librttest.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB) $(EXTRA_LIBS)

pmqtest: $(OBJDIR)/pmqtest.o $(OBJDIR)/librttest.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB) $(EXTRA_LIBS)

pip_stress: $(OBJDIR)/pip_stress.o $(OBJDIR)/librttest.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB)

hackbench: $(OBJDIR)/hackbench.o
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS)

queuelat: $(OBJDIR)/queuelat.o $(OBJDIR)/librttest.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB)

ssdd: $(OBJDIR)/ssdd.o $(OBJDIR)/librttest.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB)

oslat: $(OBJDIR)/oslat.o $(OBJDIR)/librttest.a $(OBJDIR)/librttestnuma.a
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB) $(RTTESTNUMA)

%.8.gz: %.8
	gzip -nc $< > $@

%.8.bz2: %.8
	bzip2 -c $< > $@

LIBOBJS =$(addprefix $(OBJDIR)/,rt-error.o rt-get_cpu.o rt-sched.o rt-utils.o)
$(OBJDIR)/librttest.a: $(LIBOBJS)
	$(AR) rcs $@ $^

LIBNUMAOBJS =$(addprefix $(OBJDIR)/,rt-numa.o)
$(OBJDIR)/librttestnuma.a: $(LIBNUMAOBJS)
	$(AR) rcs $@ $^

CLEANUP  = $(TARGETS) *.o .depend *.*~ *.orig *.rej *.d *.a *.8.gz *.8.bz2
CLEANUP += $(if $(wildcard .git), ChangeLog)

.PHONY: clean
clean:
	for F in $(CLEANUP); do find -type f -name $$F | xargs rm -f; done
	rm -f rt-tests-*.tar
	rm -f hwlatdetect
	rm -f get_cyclictest_snapshot
	rm -f tags

RPMDIRS = BUILD BUILDROOT RPMS SRPMS SPECS
.PHONY: distclean
distclean: clean
	rm -rf $(RPMDIRS) releases *.tar.gz *.tar.asc tmp

.PHONY: rebuild
rebuild:
	$(MAKE) clean
	$(MAKE) all

.PHONY: install
install: all install_manpages install_hwlatdetect install_get_cyclictest_snapshot
	mkdir -p "$(DESTDIR)$(bindir)"
	cp $(TARGETS) "$(DESTDIR)$(bindir)"
	install src/queuelat/determine_maximum_mpps.sh "${DESTDIR}${bindir}"

.PHONY: install_hwlatdetect
install_hwlatdetect: hwlatdetect
	if test -n "$(PYLIB)" ; then \
		mkdir -p "$(DESTDIR)$(bindir)" ; \
		install -D -m 755 src/hwlatdetect/hwlatdetect.py $(DESTDIR)$(PYLIB)/hwlatdetect.py ; \
		rm -f "$(DESTDIR)$(bindir)/hwlatdetect" ; \
		ln -s $(PYLIB)/hwlatdetect.py "$(DESTDIR)$(bindir)/hwlatdetect" ; \
	fi

.PHONY: install_get_cyclictest_snapshot
install_get_cyclictest_snapshot: get_cyclictest_snapshot
	if test -n "${PYLIB}" ; then \
		mkdir -p "${DESTDIR}${bindir}" ; \
		install -D -m 755 src/cyclictest/get_cyclictest_snapshot.py ${DESTDIR}${PYLIB}/get_cyclictest_snapshot.py ; \
		rm -f "${DESTDIR}${bindir}/get_cyclictest_snapshot" ; \
		ln -s ${PYLIB}/get_cyclictest_snapshot.py "${DESTDIR}${bindir}/get_cyclictest_snapshot" ; \
	fi

.PHONY: install_manpages
install_manpages: $(MANPAGES)
	mkdir -p "$(DESTDIR)$(mandir)/man8"
	cp $(MANPAGES) "$(DESTDIR)$(mandir)/man8"

.PHONY: tarball
tarball:
	git archive --worktree-attributes --prefix=rt-tests-${VERSION}/ -o rt-tests-${VERSION}.tar v${VERSION}

.PHONY: help
help:
	@echo ""
	@echo " rt-tests useful Makefile targets:"
	@echo ""
	@echo "    all       :  build all tests (default"
	@echo "    install   :  install tests to local filesystem"
	@echo "    clean     :  remove object files"
	@echo "    distclean :  remove all generated files"
	@echo "    tarball   :  make a rt-tests tarball suitable for release"
	@echo "    help      :  print this message"

.PHONY: tags
tags:
	ctags -R --extra=+f --c-kinds=+p --exclude=tmp --exclude=BUILD *

=== debian/changelog ===
rt-tests (2.2-1) unstable; urgency=medium

  [ Anders Roxell ]
  * update to new upstream release v1.9
  * update patches for new upstream release
  * Makefile: manpages: only add get_cyclictest_snapshot if PYLIB

  [ Punit Agrawal ]
  * Add Punit Agrawal as an uploader for rt-tests package
  * Update package repository location
  * Update to new upstream release v2.2 (Closes: #971590)
  * Refresh patches for new upstream release

 -- Punit Agrawal <punit@debian.org>  Thu, 09 Sep 2021 13:42:11 +0900

## rt-tests 2.4

=== debian/changelog ===
rt-tests (2.4-1) unstable; urgency=medium

  * Update to new upstream release v2.4

 -- Punit Agrawal <punit@debian.org>  Sat, 23 Jul 2022 06:37:41 +0100

rt-tests (2.3-1) unstable; urgency=medium

  * Update copyright to account for file rename
  * Update to new upstream release v2.3

 -- Punit Agrawal <punit@debian.org>  Sat, 21 May 2022 17:06:28 +0100

## rt-tests 2.5

=== debian/changelog ===
rt-tests (2.5-1) unstable; urgency=medium

  * Update to new upstream release v2.4

 -- Punit Agrawal <punit@debian.org>  Sat, 22 Jul 2023 07:23:43 +0100

## rt-tests 2.6

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION = 2.2
+VERSION = 2.6
 CC = $(CROSS_COMPILE)gcc
 AR = $(CROSS_COMPILE)ar
 
@@ -30,11 +30,11 @@
 bindir  ?= $(prefix)/bin
 mandir	?= $(prefix)/share/man
 
-CFLAGS ?= -Wall -Wno-nonnull
+CFLAGS ?= -Wall -Wno-nonnull -Wextra
 CPPFLAGS += -D_GNU_SOURCE -Isrc/include
 LDFLAGS ?=
 
-PYLIB  ?= $(shell python3 -c 'import distutils.sysconfig;  print (distutils.sysconfig.get_python_lib())')
+PYLIB ?= $(shell python3 -m get_pylib)
 
 # Check for errors, such as python3 not available
 ifeq (${PYLIB},)
@@ -253,4 +253,4 @@
 
 .PHONY: tags
 tags:
-	ctags -R --extra=+f --c-kinds=+p --exclude=tmp --exclude=BUILD *
+	ctags -R --extras=+f --c-kinds=+p --exclude=tmp --exclude=BUILD *

=== debian/changelog ===
rt-tests (2.6-1.1) unstable; urgency=medium

  * Non-maintainer upload
  * Add patch 0007-Fix-rt-tests-build-with-glibc-2.41.patch from upstream to
    fix build with glibc 2.41.  Closes: #1099287

 -- Aurelien Jarno <aurel32@debian.org>  Fri, 14 Mar 2025 21:57:56 +0100

rt-tests (2.6-1) unstable; urgency=medium

  * Update to new upstream release v2.6

 -- Punit Agrawal <punit@debian.org>  Sun, 24 Mar 2024 15:22:27 +0000

=== debian/control ===
Source: rt-tests
Section: misc
Priority: optional
Maintainer: Uwe Kleine-König <ukleinek@debian.org>
Uploaders: Punit Agrawal <punit@debian.org>
Standards-Version: 4.4.1
Build-Depends: debhelper-compat (= 12), libnuma-dev (>= 2.0.3)
Vcs-Browser: https://salsa.debian.org/debian/rt-tests
Vcs-Git: https://salsa.debian.org/debian/rt-tests.git

Package: rt-tests
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3,
 libnuma1 (>= 2.0.3)
Description: Test programs for rt kernels
 rt-tests contains a set of programs that test and measure various components
 of real-time kernel behavior, such as timer latency, signal latency and the
 functioning of priority-inheritance mutexes.
 Additionally it contains hackbench, a program to generate work for the
 scheduler.

=== debian/watch ===
version=4

opts="pgpsigurlmangle=s%.xz$%.sign%, decompress" \
https://www.kernel.org/pub/linux/utils/rt-tests/rt-tests-(.*)\.tar\.xz

## rt-tests 2.9

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,7 @@
-VERSION = 2.6
+# SPDX-License-Identifier: GPL-2.0-or-later
+include feature/test-feature.mak
+
+VERSION = 2.8
 CC = $(CROSS_COMPILE)gcc
 AR = $(CROSS_COMPILE)ar
 
@@ -30,11 +33,24 @@
 bindir  ?= $(prefix)/bin
 mandir	?= $(prefix)/share/man
 
-CFLAGS ?= -Wall -Wno-nonnull -Wextra
+CFLAGS ?= -Wall -Werror -Wno-nonnull -Wextra -Wno-sign-compare -Wno-unused-parameter -Wno-error=format-truncation= -Wno-error=unused-result
 CPPFLAGS += -D_GNU_SOURCE -Isrc/include
 LDFLAGS ?=
 
 PYLIB ?= $(shell python3 -m get_pylib)
+
+# Check for optional libcpupower dependency
+ifneq ($(no_libcpupower), 1)
+ifeq ($(call test-feature,libcpupower), 0)
+CPPFLAGS += -DHAVE_LIBCPUPOWER_SUPPORT
+LIBCPUPOWER += -lcpupower
+else
+$(warning libcpupower is missing, building without --deepest-idle-state support.)
+$(warning Please install libcpupower-dev/kernel-tools-libs-devel)
+endif
+else
+$(warning libcpupower disabled, building without --deepest-idle-state support.)
+endif
 
 # Check for errors, such as python3 not available
 ifeq (${PYLIB},)
@@ -119,7 +135,7 @@
 -include $(addprefix $(OBJDIR)/,$(sources:.c=.d))
 
 cyclictest: $(OBJDIR)/cyclictest.o $(OBJDIR)/librttest.a $(OBJDIR)/librttestnuma.a
-	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB) $(RTTESTNUMA)
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB) $(RTTESTNUMA) $(LIBCPUPOWER)
 
 cyclicdeadline: $(OBJDIR)/cyclicdeadline.o $(OBJDIR)/librttest.a
 	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB)
@@ -177,7 +193,8 @@
 %.8.bz2: %.8
 	bzip2 -c $< > $@
 
-LIBOBJS =$(addprefix $(OBJDIR)/,rt-error.o rt-get_cpu.o rt-sched.o rt-utils.o)
+LIBOBJS =$(addprefix $(OBJDIR)/,rt-error.o rt-get_cpu.o rt-sched.o rt-utils.o \
+	histogram.o)
 $(OBJDIR)/librttest.a: $(LIBOBJS)
 	$(AR) rcs $@ $^
 
@@ -251,6 +268,11 @@
 	@echo "    tarball   :  make a rt-tests tarball suitable for release"
 	@echo "    help      :  print this message"
 
+# Universal Ctags warns about the backward compatible option '--extra' and
+# wants it to be called '--extras'.
+CTAGS_BIN = ctags
+CTAGS_EXTRA := $(shell $(CTAGS_BIN) --version 2>&1 | grep -iq universal && echo extras || echo extra)
+
 .PHONY: tags
 tags:
-	ctags -R --extras=+f --c-kinds=+p --exclude=tmp --exclude=BUILD *
+	$(CTAGS_BIN) -R --$(CTAGS_EXTRA)=+f --c-kinds=+p --exclude=tmp --exclude=BUILD *

=== feature/Makefile ===
# SPDX-License-Identifier: GPL-2.0-or-later
all: feature-libcpupower

feature-libcpupower: $(OBJDIR)/test-libcpupower.o

$(OBJDIR)/test-libcpupower.o: feature/test-libcpupower.c
	@$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) $< -lcpupower -o $@

.PHONY: clean

clean:
	rm -f $(OBJDIR)/test-*.o

=== src/backfire/Makefile ===
# If KERNELRELEASE is defined, we've been invoked from the
# kernel build system and can use its language
ifneq ($(KERNELRELEASE),)
obj-m := backfire.o

# otherwise we were called directly from the command
# line; invoke the kernel build system.
else
KERNELDIR ?= /lib/modules/$(shell uname -r)/build

modules modules_install clean::
	make -C $(KERNELDIR) M=$(CURDIR) $@

clean::
	rm -f *.o Module.markers modules.order

endif

=== src/arch/android/Makefile ===

# Android use Bionic for libc, and this does not have
# - pthread barriers
# - pthread_[gs]etaffinity
#
# This is all handled by bionic.h based on flags we set here.

# Typically see something like "aarch64-linux-android". However, in some
# buildsystems, it will be a variation of -androidabe.
ost=$(findstring android, $(ostype))
ifeq (android,$(ost))
	USE_BIONIC := 1
	CFLAGS += -DPTHREAD_BIONIC

	LDFLAGS += -pie
# -lrt and -lpthread is in standard bionic library, no standalone library
	LIBS := $(filter-out -lrt,$(LIBS))
	LIBS := $(filter-out -lpthread,$(LIBS))

# Currently, only these binaries will compile and link properly for android
# - cyclictest
# - hackbench
	sources := cyclictest.c hackbench.c
endif

=== debian/changelog ===
rt-tests (2.9-1) unstable; urgency=medium

  [ Kevin Becker ]
  * Update to new upstream release v2.9
  * Refresh patches for upstream release v2.9
  * Standards-Version: 4.7.2 (no changes needed)

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on libnuma-dev (>= 2.0.3).
    + rt-tests: Drop versioned constraint on libnuma1 (>= 2.0.3) in Depends.

  [ Punit Agrawal ]
  * Add new dependency libcpupower
  * Update maintainer. Thank you Uwe for your contributions!

 -- Punit Agrawal <punit@debian.org>  Sat, 30 Aug 2025 21:45:40 +0100

=== debian/control ===
Source: rt-tests
Section: misc
Priority: optional
Maintainer: Punit Agrawal <punit@debian.org>
Standards-Version: 4.7.2
Build-Depends: debhelper-compat (= 12), libnuma-dev, libcpupower-dev
Vcs-Browser: https://salsa.debian.org/debian/rt-tests
Vcs-Git: https://salsa.debian.org/debian/rt-tests.git

Package: rt-tests
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3,
 libnuma1, libcpupower1
Description: Test programs for rt kernels
 rt-tests contains a set of programs that test and measure various components
 of real-time kernel behavior, such as timer latency, signal latency and the
 functioning of priority-inheritance mutexes.
 Additionally it contains hackbench, a program to generate work for the
 scheduler.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/default.mk
export EXTRA_CFLAGS = $(CFLAGS)
export DH_VERBOSE = 1

export prefix=/usr

ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 i386 ia64 mips mipsel mipsn32 mipsn32el mips64 mips64el powerpc powerpcspe ppc64 x32))
export NUMA=1
endif

%:
	dh $@
